function average_tables(test,ntsts,maxit)
% function average_tables(test,ntsts,maxit)
% this functions generates the data in Tables 4 and 5 when called with
% test=1,2,3,4 and with the number of trials nstst=100 
nograph = true;
verb = false;
fid_err_av = fopen('tab_err_av.txt','a+');
fid_cpu_av = fopen('tab_cpu_av.txt','a+');
fprintf(fid_err_av,'\n \\begin{table}\\centering\\scriptsize\\begin{tabular}{c|cccccccc}\n');
fprintf(fid_err_av,'n&Direct&Schur&Polar&(11)&(12)&(14)&(15)&(19)\\\\ \\hline\n');
fprintf(fid_cpu_av,'\n \\begin{table}\\centering\\scriptsize\\begin{tabular}{c|cccccccc}\n');
fprintf(fid_cpu_av,'n&Direct&Schur&Polar&(11)&(12)&(14)&(15)&(19)\\\\ \\hline\n');

n=50;
for nn=1:3
    n=n*2;
    fprintf('n=%d\n',n)
    e7=0;e8=0;e9=0;e10=0;e11=0;e15=0;esc=0;epb=0;edir=0;
    t7=0;t8=0;t9=0;t10=0;t11=0;t15=0;tsc=0;tpb=0;tdir=0;
    for nt=1:ntsts
       [A, B, stata, statb]=data_set(test,ntsts,n);
       fprintf('nt=%d computing in high precision...\n',nt);
% Computing in high precision:
       a = A{nt}; b=B{nt};
       aa=mp(a); bb=mp(b);
       tic; g=polar_based_mean_it_mp(aa,bb,verb,maxit,nograph);tim=toc;
       g = double(g); ng=norm(g);
       fprintf('elapsed time=%d ...continuing in double...\n',tim);
% Direct computation
       tic; gdir = directmean(a,b); tc = toc; tdir=tdir+tc;
% Schur-Cholesky
       tic; gsc = cholesky_schur_mean(a,b,0.5); tc = toc; tsc=tsc+tc;
% Polar-based
       tic; gpb = polar_based_mean_direct(a,b); tc = toc; tpb=tpb+tc;
% Iterative algorithms
       tic; g7 = avit(a,b,false,maxit,nograph); tc = toc; t7=t7+tc;
       tic; g8 = avit1(a,b,verb,maxit,nograph); tc = toc; t8=t8+tc;
       tic; [g10,er10] = avit_3_term_scaled(a,b,verb,maxit,nograph); tc = toc; t10=t10+tc;
       tic; g11 = avit_sign_scaled(a,b,verb,maxit,nograph); tc = toc; t11=t11+tc;
       tic; g15 = polar_based_mean_it(a,b,verb,maxit,nograph); tc = toc; t15=t15+tc;
       edir=edir+norm(gdir-g)/ng;
       esc = esc+norm(gsc-g)/ng;
       epb = epb+norm(gpb-g)/ng;
       e7 = e7+norm(g7-g)/ng;
       e8 = e8+norm(g8-g)/ng;
       nx=norm(g10-g);
       if nx>1.e-8
          fprintf('nt=%d, err=%d\n',nt,er10)
          fprintf('%d,%d,%d,%d,%d,%d,%d,%d\n',norm(gdir-g),norm(gsc-g),...
          norm(gpb-g),norm(g7-g),norm(g8-g),norm(g10-g),norm(g11-g),norm(g15-g));
          pause
       end
       e10 = e10+norm(g10-g)/ng;
       e11 = e11+norm(g11-g)/ng;
       e15 = e15+norm(g15-g)/ng;
    end
    edir=edir/ntsts; esc=esc/ntsts;epb=epb/ntsts;
    tdir=tdir/ntsts; tsc=tsc/ntsts;tpb=tpb/ntsts;

    e7=e7/ntsts; e8=e8/ntsts; e10=e10/ntsts; e11=e11/ntsts; e15=e15/ntsts;
    t7=t7/ntsts; t8=t8/ntsts; t10=t10/ntsts; t11=t11/ntsts; t15=t15/ntsts;

    fprintf(fid_err_av, ...
      '%d & %3.1e & %3.1e & %3.1e & %3.1e & %3.1e & %3.1e & %3.1e & %3.1e \\\\ \n',...
      n, edir, esc, epb, e7, e8, e10, e11, e15);
    fprintf(fid_cpu_av, ...
      '%d & %3.1e & %3.1e & %3.1e & %3.1e & %3.1e & %3.1e & %3.1e & %3.1e \\\\ \n',...
      n, tdir, tsc, tpb, t7, t8, t10, t11, t15);
end
    fprintf(fid_err_av,'\\end{tabular}\\caption{----}\\label{tab:}\\end{table}\n');
    fprintf(fid_cpu_av,'\\end{tabular}\\caption{----}\\label{tab:}\\end{table}\n');
end
