function g = cholesky_schur_mean(a,b,t)
% function g = cholesky_schur_mean(a,b,t)
% weighted mean g = A #_t B of spd matrices a,b computed through the
% Cholesky factorization and the Schur form
  if rcond(a)<rcond(b)
     s = b;
     b = a;
     a = s;
  end
  r = chol(a);
  c = r'\b/r;
  [q,d] = schur(c);
  d = diag(d); d = d.^t;
  g = r'*(q*diag(d)*q')*r;
end
