function plotgraphs_average(test,ntests)
% function plotgraphs_average(test,ntests) 
% this function plots the graph of the average of the errors 
% w.r.t. the size n for n = 10,20,...,200, out of 'ntests' trials,
% for the matrix mean of two matrices
% the variable 'test' can take the values 1,2,3,4, 
% suggested value for the variable 'ntests' is 100
% The function generates the plots in Figure 2 of the paper
% Bini, Iannazzo, Computational aspects of the geometric mean of
% two matrices: a survey
% This function requires the package Advanpix for the multiprecision
% arithmetic

verb = false; maxit = 30;nograph = true;
% ntests = 100;
% test = 4;
% Random, matrices
tt = [10:10:200];
i = 0;
alg11 = zeros(20,1);  alg12 = alg11; alg14 = alg11; alg15 = alg11; alg19 = alg11;
algch = alg11; algdir = alg11; algpb = alg11;
for n=10:10:200
    fprintf('Testing for n=%d\n',n);
   i = i+1;
   [A, B]=data_set(test,ntests,n);
   for nt=1:ntests
      a = A{nt}; b = B{nt};
      amp=mp(a); bmp=(b);
      G = polar_based_mean_it_mp(amp,bmp,false,30,true);
 % gpb
      g = polar_based_mean_direct(a,b);
      algpb(i)=algpb(i)+norm(g-G);
 %gdir
      g = directmean(a,b);
      algdir(i)=algdir(i)+norm(g-G);
 % chol
      g=cholesky_schur_mean(a,b,1/2);
      algch(i)=algch(i)+norm(g-G);   
 % 11 - 7
      g=avit(a,b,verb,maxit,nograph);
      alg11(i)=alg11(i)+norm(g-G);
 % 12 - 8
      g=avit1(a,b,verb,maxit,nograph);
      alg12(i)=alg12(i)+norm(g-G);
 % 14 - 10
      g=avit_3_term_scaled(a,b,verb,maxit,nograph);
      alg14(i)=alg14(i)+norm(g-G);
 % 15 - 11
      g=avit_sign_scaled(a,b,verb,maxit,nograph);
      alg15(i)=alg15(i)+norm(g-G);
 % 19 - 15
      g=polar_based_mean_it(a,b,verb,maxit,nograph);
      alg19(i)=alg19(i)+norm(g-G);
   end
end

algch = algch/ntests;
alg11 = alg11/ntests;
alg12 = alg12/ntests;
alg14 = alg14/ntests;
alg15 = alg15/ntests;
alg19 = alg19/ntests;
algdir=algdir/ntests;
algpb=algpb/ntests;

figure


semilogy(tt,algch,'-*','linewidth',2,'markersize',8);hold on
semilogy(tt,algdir,'-x','linewidth',2,'markersize',8);
semilogy(tt,algpb,'-+','linewidth',2,'markersize',8);
semilogy(tt,alg11,'-d','linewidth',2,'markersize',8);
semilogy(tt,alg12,'-o','linewidth',2,'markersize',8);
semilogy(tt,alg14,'-s','linewidth',2,'markersize',8);
semilogy(tt,alg15,'-^','linewidth',2,'markersize',8);
semilogy(tt,alg19,'->','linewidth',2,'markersize',8);
legend('Schur','dir','polar','(11)','(12)','(14)','(15)','(19)');

