function [z,err] = polar(s,verbose,maxit,nograph)
% function [z,err] = polar(s,verbose,maxit,nograph)
% The polar factor z  is computed by means of the iteration (19) 
epsi = 1.e-14;
z0 = s;nrm = norm(z0,inf);
erold = inf; err = 0;
for it=1:maxit
    zi = inv(z0);
    gk = norm(zi,1)*norm(zi,inf );
    gk = gk/(norm(z0,1)*norm(z0,inf ));
    gk = gk^(1/4);
    gki = 1/gk;
    z1 = 0.5*(gk*z0+(gki*zi)');
    er = norm(z1-z0,inf);
    z0 = z1;
    err(it) = er/nrm;
    if verbose
        fprintf('it=%d, err=%e\n',it,er/nrm);
    end
    if (er<epsi*nrm || (er>erold &&it>10)) && nograph
        z = z1;
        return
    end
    erold = er;
end
z = z1;
