function g = polar_based_mean_direct(a,b);
% function g = polar_based_mean_direct(a,b);
% The matrix geometric mean g is computed by means of the polar decomposition
% where the polar factor is computed directly through its definition
% relying on the Matlab function sqrtm and on the cholesky factorization 
if rcond(a)<rcond(b)
     s = b;
     b = a;
     a = s;
end
r=chol(a);la=r';
r=chol(b);lb=r';
s=(la\lb)';
u=s/sqrtm(s'*s);
g=lb*u*la';
